# -*- coding:utf-8 -*-
"""
This program is free software.This program is distributed 
WITHOUT ANY WARRANTY.You should use it on your own risk. 

You can modify/redistribute it under the terms of the 
GNU General Public License version 2 or later.

"""
__scriptname__ = 'PyMyViewer'
__version__ = '0.03(0)'
__author__ = 'masa'
__web__ = 'http://masaland.cocolog-nifty.com/'
__copyright__ = 'Copyright (C) 2008-2017 masa'


import sys
import os
if not hasattr(sys, "setdefaultencoding"):
    wk = sys.stdout
    reload(sys)
    sys.stdout = wk
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import e32
import appuifw
import graphics
import re
import dir_iter
try:
    from PyFbuiutil import Fbrowser
    Err_exit = 0
except:
    rtn = appuifw.query(unicode("Please install PyFbuiutl.py"), "query")
#    sys.exit(0)
    Err_exit = 1


#### Please change here or INI_FILE.
#### If INI_FILE exists,INI_FILE is used instead of this part.
INI_FILE   = 'E:\\Data\\masa\\PyMyViewer.ini'
Home_path  = 'E:\\Images\\'
Error_image = 'E:\\Data\\masa\\error_image.jpg'
#

# other global variables,no need to change
Menu_msg = ['PyMyViewer '+__version__,'Jpg Viewer']

#### view size = normal ################################

## 360*640 screen
pxn0,pxn1,pxn2      = 16, 132, 248 # 16+(96+20)*n
pyn0,pyn1,pyn2,pyn3 = 15, 132, 249, 366 # 15+(72+5+20+5+15)*n
ptn0,ptn1,ptn2,ptn3 = 112, 229, 346, 463 # (15+72+5+20)+(5+15+72+5+20)*n
pos_listn0 =[[pxn0,pyn0,ptn0],[pxn1,pyn0,ptn0],[pxn2,pyn0,ptn0],
			 [pxn0,pyn1,ptn1],[pxn1,pyn1,ptn1],[pxn2,pyn1,ptn1],
			 [pxn0,pyn2,ptn2],[pxn1,pyn2,ptn2],[pxn2,pyn2,ptn2],
			 [pxn0,pyn3,ptn3],[pxn1,pyn3,ptn3],[pxn2,pyn3,ptn3]]
Max_cntn0 = 12
Widthn0, Heightn0 = 96,72

## QVGA
pxn0,pxn1,pxn2 = 4, 84, 164 # 4+(72+8)*n
pyn0,pyn1,pyn2 = 3, 84, 165 # 3+(54+2+20+2+3)*n
ptn0,ptn1,ptn2 = 79, 160, 241 # (3+54+2+20)+(2+3+54+2+20)*n
pos_listn1 =[[pxn0,pyn0,ptn0],[pxn1,pyn0,ptn0],[pxn2,pyn0,ptn0],
			 [pxn0,pyn1,ptn1],[pxn1,pyn1,ptn1],[pxn2,pyn1,ptn1],
			 [pxn0,pyn2,ptn2],[pxn1,pyn2,ptn2],[pxn2,pyn2,ptn2]]
Max_cntn1 = 9
Widthn1, Heightn1 = 72,54

#### view size = big ##################################

## 360*640 screen
pxb0,pxb1      = 16, 180 # 16+(144+20)*n
pyb0,pyb1,pyb2 = 15, 168, 321 # 15+(108+5+20+5+15)*n
ptb0,ptb1,ptb2 = 148, 301, 454 # (15+108+5+20)+(5+15+108+5+20)*n
pos_listb0= [[pxb0,pyb0,ptb0],[pxb1,pyb0,ptb0],
			 [pxb0,pyb1,ptb1],[pxb1,pyb1,ptb1],
			 [pxb0,pyb2,ptb2],[pxb1,pyb2,ptb2]]
Max_cntb0 = 6
Widthb0, Heightb0 = 144,108

## QVGA
pxb0,pxb1 = 6, 126 # 6+(110+10)*n
pyb0,pyb1 = 8, 123 # 8+(83+2+20+2+8)*n
ptb0,ptb1 = 113, 228 # (8+83+2+20)+(2+8+83+2+20)*n
pos_listb1= [[pxb0,pyb0,ptb0],[pxb1,pyb0,ptb0],
			 [pxb0,pyb1,ptb1],[pxb1,pyb1,ptb1]]
Max_cntb1 = 4
Widthb1, Heightb1 = 110,83

######################################################

class Viewer:
    def __init__(self):
        self.v_lock = e32.Ao_lock()
        self.WIDTH  = Widthn0
        self.HEIGHT = Heightn0
        self.pos_list = pos_listn0
        self.Max_cnt = Max_cntn0
        self.Display_img = ''
        self.state = 0
        self.disp_img_list = []
        self.name_list = []
        self.Disp_size = 0 # (0:normal 1:big  /360*640)(2:normal 3:big  /QVGA)
        self.auto_transpose = 0 #1:大きく表示できる向きに各画像向きを自動調整する
        self.gray_bg = 0 # 画像表示時の背景色 0:黒（デフォルト）  1:灰色


    def run(self):
        self.In_path = Home_path
        self.index = ''
        self.cnt = 0
        self.Fb = Fbrowser("Select")
        appuifw.app.directional_pad = False #for 5800XM
        self.canvas = appuifw.Canvas(redraw_callback=lambda rect:self.redraw_cb())
        appuifw.app.body = self.canvas
#        appuifw.app.orientation='portrait'          # *1 (place *1 before *2)
        self.cwidth,self.cheight = self.canvas.size # *2
        if (self.cwidth > 350) or (self.cheight > 350):  #screen 360*640 phone
            self.pos_list = pos_listn0
            self.WIDTH, self.HEIGHT = Widthn0, Heightn0
            self.Max_cnt = Max_cntn0
            self.Disp_size = 0
        else: #QVGA phone
            self.pos_list = pos_listn1
            self.WIDTH, self.HEIGHT = Widthn1, Heightn1
            self.Max_cnt = Max_cntn1
            self.Disp_size = 2
        self.refresh()
        self.v_lock.wait()
        appuifw.app.orientation='automatic'
        del self.Fb

    def refresh(self,msg=Menu_msg):
        self.disp_msg(msg,fontsize='normal')
        self.set_dirmenu()
        self.state = 0
        appuifw.app.orientation='automatic'

    def show_er_val(self,file_name):
        import sys
        type, value = sys.exc_info() [:2]
        #appuifw.note(unicode(str(type)+'\n'+str(value)), 'error')
        rtn = appuifw.query(unicode(str(type)+'\n'+str(value)+'\n'+file_name), 'query')


    def sel_dir(self):
        sel_path = self.Fb.select(default_path = self.In_path)
        self.disp_msg(u'') #
        if sel_path:
            self.In_path = sel_path[0]
            self.view_image()
        else:
            self.refresh()


    def home_dir(self):
        self.In_path = Home_path
        if os.path.isdir(self.In_path):
            self.view_image()
        else:
            rtn = appuifw.query(unicode('No Home_dir or not dir\n' + \
                                           self.In_path),'query')
            self.refresh()


    def change_size(self, flg=0):
        if flg == 1: # display size = big
            if self.Disp_size < 2: # 0 or 1 (360*640)
                self.Disp_size = 1    # big
                self.pos_list = pos_listb0
                self.Max_cnt = Max_cntb0
                self.WIDTH, self.HEIGHT = Widthb0, Heightb0
                msg = ' (display 2x3)'
            else: # 2 or 3 (QVGA)
                self.Disp_size = 3    # big
                self.pos_list = pos_listb1
                self.Max_cnt = Max_cntb1
                self.WIDTH, self.HEIGHT = Widthb1, Heightb1
                msg = ' (display 2x2)'
        else: # display size = normal
            if self.Disp_size < 2: # 0 or 1 (360*640)
                self.Disp_size = 0    # normal
                self.pos_list = pos_listn0
                self.Max_cnt = Max_cntn0
                self.WIDTH, self.HEIGHT = Widthn0, Heightn0
                msg = ' (display 3x4)'
            else: # 2 or 3 (QVGA)
                self.Disp_size = 2    # normal
                self.pos_list = pos_listn1
                self.Max_cnt = Max_cntn1
                self.WIDTH, self.HEIGHT = Widthn1, Heightn1
                msg = ' (display 3x3)'
        msg = Menu_msg + [' size changed', msg]
        self.disp_msg(msg, fontsize='normal')


    def change_transpose(self, flg=0):
        if flg == 1:
            self.auto_transpose = 1
            msg = ' Auto transpose'
        else:
            self.auto_transpose = 0
            msg = ' No transpose'
        msg = Menu_msg + [' Option changed', msg]
        self.disp_msg(msg, fontsize='normal')


    def change_bg_color(self, flg=0):
        if flg == 1: #bg color gray
            self.gray_bg = 1
        else:
            self.gray_bg = 0
        self.draw_state()


    def selected_exit(self):
        self.EXIT_FLG = 1
        self.v_lock.signal()

    def selected_can(self):
        self.CAN_FLG = 1
        self.index = ''
        self.cnt = 0
        self.refresh()

    def do_dummy(self):
        pass

    def set_mainmenu(self):
        appuifw.app.title = unicode(__scriptname__ + '  ' + __version__)
        appuifw.app.exit_key_handler = lambda:self.selected_exit() 
        appuifw.app.menu = [(unicode('Exit'), self.selected_exit)] 

    def set_submenu(self):
        appuifw.app.title = unicode(__scriptname__ + '  ' + __version__)
#        appuifw.app.exit_key_handler = lambda:self.selected_exit()
        appuifw.app.exit_key_handler = lambda:self.selected_can()
        appuifw.app.menu = [(unicode('OK/Next'),self.view_image),
                            (unicode('Cancel'),self.selected_can ),
                            (unicode('Background color'),
                               ((unicode('Black'),lambda:self.change_bg_color(0)),
                                (unicode('Gray'), lambda:self.change_bg_color(1)))),
                            (unicode('Exit'), self.selected_exit)]

    def set_dirmenu(self):
        appuifw.app.title = unicode(__scriptname__ + '  ' + __version__)
        appuifw.app.exit_key_handler = lambda:self.selected_exit()
        appuifw.app.menu = [(unicode('View image'),
                               ((unicode('Go to select dir'),self.sel_dir),
                                (unicode('Go to Home dir'),self.home_dir),
                                (unicode('Current dir'), self.view_image))),
                            (unicode('Display image size'),
                               ((unicode('Normal'),lambda:self.change_size(0)),
                                (unicode('Big'),   lambda:self.change_size(1)))),
                            (unicode('Transpose'),
                               ((unicode('No transpose'),  lambda:self.change_transpose(0)),
                                (unicode('Auto transpose'),lambda:self.change_transpose(1)))),
                            (unicode('Exit'), self.selected_exit)]


    def disp_msg(self,msg,fontsize='dense'):
        appuifw.app.body = self.canvas
#        txt_img = graphics.Image.new(self.canvas.size)
#        txt_img.rectangle(((0,0),(self.canvas.size)),fill=(0,0,0))
        txt_img = graphics.Image.new((640, 640))  # orientation に関係ない大きさで
        txt_img.clear((0,0,0))                    # backを用意する
        for i in range(len(msg)):
            py = 46 + 45 * (i)
            if msg[i]:
                txt_img.text((20,py), unicode(msg[i]), \
                        fill=(255,255,255), font=fontsize)
        self.Display_img = txt_img
        self.canvas.blit(txt_img)


    def redraw_cb(self):
        if self.state == 2:
            if self.disp_img_list:
                self.draw_state()
            elif self.Display_img:
                self.canvas.blit(self.Display_img)
        elif self.state == 1:
            if self.Display_img:
                self.canvas.blit(self.Display_img)
        elif self.state == 0:
            if not self.Display_img:
                gwidth, gheight = self.canvas.size
                txt_img = graphics.Image.new((gwidth,gheight))
                txt_img.clear((0,0,0))
                txt_img.text((20,80), unicode('Jpg Viewer', 'utf-8'), \
                            fill=(255,255,255), font='title')
                self.Display_img = txt_img
            self.canvas.blit(self.Display_img)


    def draw_state(self):
        txt_img = graphics.Image.new(self.canvas.size)
        if self.gray_bg == 0: #back ground = black
            txt_img.rectangle(((0,0),(self.canvas.size)),fill=(0,0,0))
        else:
            txt_img.rectangle(((0,0),(self.canvas.size)),fill=(80,80,80))

        for i in range(len(self.disp_img_list)):
            pos_x = self.pos_list[i][0]
            pos_y = self.pos_list[i][1]
            pos_t = self.pos_list[i][2]
            if self.Disp_size == 2: #QVGA normal
                dName = unicode(self.name_list[i])[0:6]
            else:
                dName = unicode(self.name_list[i])[0:8]
            txt_img.text((pos_x,pos_t), dName, \
                    fill=(255,255,255), font='symbol')
        self.canvas.blit(txt_img)

        for i in range(len(self.disp_img_list)):
            pos_x = self.pos_list[i][0]
            pos_y = self.pos_list[i][1]
            self.canvas.blit(self.disp_img_list[i], target=(pos_x,pos_y), \
                             source=((0,0), self.disp_img_list[i].size))


    def view_image(self):
        self.EXIT_FLG = 0
        self.CAN_FLG = 0
        self.state = 1
        self.Display_img = ''
        self.disp_img_list = []
        self.name_list = []
        self.disp_msg(u'')  # clear screen

        self.set_submenu()

#       ビューの初回ならリスト作成（OKで来る2回目以降は作成しない）
        if not self.index:
            self.filelist = [x.decode('utf-8') for x in os.listdir(self.In_path) \
				if os.path.isfile(os.path.join(self.In_path, x)) and \
				(os.path.splitext(x)[1][1:3]).lower() == "jp" ]
            if self.filelist == []:
                self.disp_msg(['', '＊＊No JPG File in dir＊＊'],fontsize='normal')
                self.set_dirmenu()
                return

            self.filelist.sort()
            self.filelist.reverse()

            menu_list = [u'file select',u'all files',u'cancel']
            menu = appuifw.selection_list(menu_list)
            if menu == 0:
                self.index = appuifw.multi_selection_list(choices=self.filelist)
                if not self.index:
                    self.refresh()
                    return #exit
            elif menu == 1:
                self.index = [x for x in range(len(self.filelist))]
            else:
                self.refresh()
                return #exit

#       ビュー処理
        appuifw.app.orientation='portrait'
        p = 0
        for r in range(self.cnt, len(self.index)):
            x = self.index[r]
            file_name = self.filelist[x]
            self.name_list.append(os.path.splitext(file_name)[0])

            FILE = os.path.join(self.In_path, file_name)

#           処理中表示 （処理中、枚数/画面最大枚数、ファイル名）
            self.disp_msg(['',
                           '＊画像処理中＊',
                           '  -'+ str(p+1)+'/'+str(self.Max_cnt)+'-',
                           '  '+file_name[0:14]],fontsize='normal')
            try:
                img = graphics.Image.open(FILE)
            except:
                self.show_er_val(file_name)
                try:
                    img = graphics.Image.open(Error_image)
                except:
                    self.disp_msg(['', '＊＊No Error_image file＊＊'],fontsize='normal')
                    self.index = ''
                    self.set_dirmenu()
                    return

            # 横長に揃える
            if self.auto_transpose:
                img_width, img_height = img.size
                if img_height > img_width :
                    img = img.transpose(graphics.ROTATE_270)
            #add image to list
            self.disp_img_list.append(img.resize((self.WIDTH, self.HEIGHT),keepaspect=1))

            p = p + 1
            self.cnt = self.cnt + 1

            if p == self.Max_cnt:  #screen full
                self.set_submenu()
                self.state = 2
                self.draw_state()
                p = 0
                if self.cnt >= len(self.index): #002(1) no more picture
                    self.index = ''             #002(1)
                    self.cnt = 0                #002(1)
                break

            if self.EXIT_FLG or self.CAN_FLG:
                self.index = ''
                self.cnt = 0
                self.state = 0
                break

        else:   # no more picture
            self.set_submenu()
            self.state = 2
            self.draw_state()
            self.index = ''
            self.cnt = 0
        self.Display_img = ''

def confread():
    global Home_path
    global Error_image
    try:
        f = open(INI_FILE,'r')
        fData = f.read()
        f.close
    except:
        return
    fData = unicode(fData)

    #split by \n and omit line that contain only (CR/LF)
    lnDatalist = [x for x in fData.split(u"\n") if len(x) > 1]

    for lnData in lnDatalist:
        lnDatawk = re.sub(u"[ \t]+",u" ",lnData)
        lnDatawk = (re.sub(u"[\n\r]+",u"",lnDatawk)).strip()
        confData=lnDatawk.split(u" ")
        if len(confData) < 2: continue # no confData[1] error
        if confData[0]   == u"Home_path" : Home_path = (confData[1])
        if confData[0]   == u"Error_image" : Error_image = (confData[1])


def main():
    """メインの関数"""
    old_title = appuifw.app.title
    confread()
    View = Viewer()
    View.run()
    appuifw.app.title = old_title


if __name__ == '__main__':
    if Err_exit == 0:
        main()
#appuifw.app.set_exit()
#sys.exit()
